<?php
class CfpExceptionDialog {
    protected function __construct() {
    }

    public static function register() {
        return set_exception_handler(array(__CLASS__, 'handler'));
    }

    public static function handler(Exception $exception) {
        $dlg = new GtkMessageDialog(
            null,
            Gtk::DIALOG_MODAL,
            Gtk::MESSAGE_ERROR,
            Gtk::BUTTONS_OK
        );
        $dlg->set_title("Fatal Error: Unhandled Exception!");

        $dlg->set_icon(
            $dlg->render_icon(
                Gtk::STOCK_DIALOG_ERROR,
                Gtk::ICON_SIZE_DIALOG
            )
        );

        $message = "<b>Fatal Error: Unhandled Exception!</b>\n\n"
                 . "An unhandled error has occured whilst operating this "
                 . "application and the application will now be terminated.\n\n"
                 . "<b>Details:</b>\n\n"
                 . "<small><tt>";
        if( $exception->getMessage() != "" ) {
            $message .= $exception->getMessage()."\n\n";
        }
        $message .= "Type: ".get_class($exception)."\n"
                 .  "Code: ".$exception->getCode()."\n"
                 .  "File: ".$exception->getFile()."\n"
                 .  "Line: ".$exception->getLine()."\n"
                 .  "Version: ".CONF_CFP_VERSION."\n\n"
                 .  "Stack Trace:\n".$exception->getTraceAsString()
                 .  "</tt></small>";
        $dlg->set_markup($message);

        $dlg->run();
        print $exception;
        exit(1);
    }
}
?>
