<?php
class CfpIoException extends Exception {

}

class CfpXmlValidationException extends Exception {
    public function __construct($message=null, $code=0, $filename=null, $lineno=null) {
        parent::__construct($message, $code);
        if($filename !== null) {
            $this->file = $filename;
        }
        if($lineno !== null) {
            $this->line = $lineno;
        }
    }

    public static function newFromLibXMLError(LibXMLError $error) {
        return new self($error->message, $error->code, $error->file, $error->line);
    }
}

class CfpHttpException extends RuntimeException {
}
?>